package com.banesco.module.payment_instruction_request.application.service;

import com.banesco.common.application.helper.MessageHelper;
import com.banesco.common.application.helper.RequestValidatorHelper;
import com.banesco.common.domain.exception.HttpStatusCodeException;
import com.banesco.common.domain.model.*;
import com.banesco.module.payment_instruction_request.application.usecase.BusinessUseCase;
import com.banesco.module.payment_instruction_request.application.usecase.PaymentInstructionRequestUseCase;
import com.banesco.module.payment_instruction_request.domain.dto.request.PaymentInstructionRequestRequest;
import com.banesco.module.payment_instruction_request.domain.dto.response.PaymentInstructionRequestResponse;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Inject;
import jakarta.ws.rs.core.Response;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ApplicationScoped
public class PaymentInstructionRequestService implements PaymentInstructionRequestUseCase {

    private final MessageHelper messageHelper;
    private final RequestValidatorHelper requestValidatorHelper;
    private final BusinessUseCase businessUseCase;

    @Inject
    public PaymentInstructionRequestService(
        MessageHelper messageHelper,
        RequestValidatorHelper requestValidatorHelper,
        BusinessUseCase businessUseCase
    ) {
        this.messageHelper = messageHelper;
        this.requestValidatorHelper = requestValidatorHelper;
        this.businessUseCase = businessUseCase;
    }

    @Override
    public Response execute(
        PaymentInstructionRequestRequest request
    ) {
        log.info("Iniciando ejecucion para el archivo: {}", request.getRecipientId());

        Response response;

        try {
            validate(request);

            ApiResponse<PaymentInstructionRequestResponse> apiResponse = business(request);

            response = messageHelper.handleSuccess(
                apiResponse.getData(),
                apiResponse.getStatusResponse().getStatusCode()
            );
        } catch (HttpStatusCodeException e) {
            log.error("Excepcion HTTP del api de negocio: {} - {}", e.getStatusCode(), e.getErrorCode());
            response = messageHelper.handleException(e);
        } catch (Exception e) {
            log.error("Excepcion generica del api de negocio: {}", e.getMessage());
            response = messageHelper.handleGenericException(e);
        }

        return response;
    }

    private void validate(
        PaymentInstructionRequestRequest request
    ) {
        requestValidatorHelper.validateRequired(request);
        requestValidatorHelper.validateFieldValues(request);
    }

    private ApiResponse<PaymentInstructionRequestResponse> business(
        PaymentInstructionRequestRequest request
    ) {
        log.info("Ejecutando llamada al api de negocio: {}", request.getAppId());
        return businessUseCase.execute(request, PaymentInstructionRequestResponse.class);
    }
}